; -----------------------------------------------------------------------------
; RetroForth for Linux       | This port was originally written by:
; http://www.retroforth.org  | * Tom Novelli *
; -----------------------------------------------------------------------------
macro section a { }
include "macros.fasm"

format elf executable
entry main

main:
	call init_retroforth
	call interpret
;---------------------------------------------------------------------
code 'emit', emit	
	push ebx,ecx,edx
	mov ebx, 1	;stdout
	mov edx, ebx	;count
	lea ecx, [esp-4]
	mov [ecx], eax
	mov eax, 4	;sys_write
	int 80h
	pop ebx,ecx,edx
	drop
	ret
code 'key', key
	dup
	push ebx,ecx,edx
	sub ebx,ebx	;0 = stdin
	mov edx, 1	;count
	lea ecx, [esp-4]
	mov eax, 3	;sys_read
	int 80h
	mov eax, [ecx]
	pop ebx,ecx,edx
	ret
;---------------------------------------------------------------------
code 'bye', linux_bye	
	sub ebx,ebx	;Return exit status 0
	mov eax,ebx
	inc eax		;1 = sys_exit
	int 80h

;
code 'syscall', linux_syscall

       ; syscalls can take a variable number of arguments, from 0 to 6.
       ; The args go in ebx, ecx, edx, esi, edi, ebp, in that order.
       ; (this is from the Linux Assembly HOWTO)

       ; At entry, the Forth stack holds args, argcount, syscall-number

       ; validate argcount, if > 6 return without changing the stack
           cmp dword [esi], 6
           jbe lsc_ok
           ret
lsc_ok:                             ; do a swap on the data stack
           push eax
           mov eax, [esi]
           pop dword [esi]         ; swapped eax=argcount

           mov [lsc_rsp], esp      ; save current return stack
           mov esp, esi            ; now point return stack to data stack
           dec eax                 ; adjust and set s flag
           js  lsc_0               ;   if 0 jump to first index
           mov eax, [lsc_tbl+eax*4]    ; index into jump table
           jmp eax

           ; entered the pop statements individually for clarity.

lsc_0:      pop eax
           jmp lsc_m
lsc_1:      pop eax
           pop ebx
           jmp lsc_m
lsc_2:      pop eax
           pop ebx
           pop ecx
           jmp lsc_m
lsc_3:      pop eax
           pop ebx
           pop ecx
           pop edx
           jmp lsc_m
lsc_4:      pop eax
           pop ebx
           pop ecx
           pop edx
           pop esi
           jmp lsc_m
lsc_5:      pop eax
           pop ebx
           pop ecx
           pop edx
           pop esi
           pop edi
           jmp lsc_m
lsc_6:      pop eax
           pop ebx
           pop ecx
           pop edx
           pop esi
           pop edi
           pop ebp
           ;  fall through
lsc_m:      int 80h
           mov esi, esp            ; restore adjusted data stack
           mov esp, [lsc_rsp]      ; restore the return stack
           ret

lsc_rsp:    dd 0
lsc_tbl:    dd lsc_1
           dd lsc_2
           dd lsc_3
           dd lsc_4
           dd lsc_5
           dd lsc_6

; syscall interface ends here

;---------------------------------------------------------------------
include "retroforth.asm"
